#ifndef CKCoreAppleMusicKit_h
#define CKCoreAppleMusicKit_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #import <UIKit/UIKit.h>
#endif

NS_ASSUME_NONNULL_BEGIN

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreAppleMusicKit: NSObject

@property (nonatomic) NSString              *developerToken;

- (void)                   registerUser:(void (^)(Boolean isSuccess, NSError *error)) completionBlock;
- (NSURLSessionDataTask *) searchForSongsByISRC:(NSString *) withStoreFront withISRCList:(NSArray *) withISRCList completionBlock:(void (^)(NSArray <NSDictionary *> *searchResults, NSError * _Nullable error, NSInteger statusCode)) completionBlock;
- (void)                   cleanUp;
- (NSURLSessionDataTask *) createPlaylist:(NSString *) withName withDescription:(NSString *) withDescription withSongsID:(NSArray <NSNumber *> *) withSongsID completionBlock:(void (^)(NSDictionary *results, NSError * _Nullable error, NSInteger statusCode)) completionBlock;

@end

NS_ASSUME_NONNULL_END

#endif

