#ifndef CKCoreAudioRecord_h
#define CKCoreAudioRecord_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #import <CodKits_macOS/CodKits_macOS.h>
#else
  #import <CodKits_iOS/CodKits_iOS.h>
#endif

#import <AVFoundation/AVFoundation.h>

NS_ASSUME_NONNULL_BEGIN

//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreAudioRecordData : NSObject
  {
  @public int               numberOfChannels;
  @public CGFloat           peakdBForChannel[2];
  @public CGFloat           averagedBForChannel[2];
  @public CGFloat           peakRMSForChannel[2];
  @public CGFloat           averageRMSForChannel[2];
  @public AVAudioPCMBuffer *audioBuffer;
  }
@end

typedef void (^CKCoreAudioRecordBlock)(CKCoreAudioRecordData *data);
typedef void (^CKCoreAudioRecordRouteChangedBlock)(AVAudioSessionRouteChangeReason reason);

//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreAudioRecord : NSObject

@property (nonatomic) Boolean          isCapturing;

- (Boolean) initCapture:(CGFloat) withSampleRate withNumberOfChannels:(int) withNumberOfChannels;
- (Boolean) initCapture:(CGFloat) withSampleRate withNumberOfChannels:(int) withNumberOfChannels withOutputFilepath:(NSURL *) withOutputFileUrl;
- (Boolean) startCaptureWithInputSource:(AVAudioSessionPortDescription *) inputSource progressBlock:(CKCoreAudioRecordBlock) progressBlock routeChangedBlock:(CKCoreAudioRecordRouteChangedBlock) routeChangedBlock;
- (void)    endCapture;
- (void)    cleanUp;

@end

NS_ASSUME_NONNULL_END

#endif

