#ifndef CKCoreAudioTools_h
#define CKCoreAudioTools_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreAudioTools

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreAudioMergeTracks : NSObject

- (void) proceed:(NSArray <AVURLAsset *> *) withAudioAssets withAudioVolumes:(NSArray <NSNumber *> *) withAudioVolumes toDestinationUrl:(NSURL *) toDestinationUrl completionBlock:(void (^)(Boolean isSuccess, NSError *error)) completionBlock progressBlock:(void (^)(CGFloat progress)) progressBlock;
- (void) cleanUp;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreAudioWAVHeader: NSObject

+ (NSData *) createWAVHeader:(unsigned int) channels sampleRate:(unsigned int) sampleRate sampleBytes:(unsigned int) sampleBytes samplesCount:(unsigned int) samplesCount;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreAudioMetadata: NSObject

+ (void) albumCoverFromUrl:(NSURL *) withUrl completionBlock:(void (^)(NSImage *coverImage)) completionBlock;

@end

#endif

