#ifndef CKCoreButtonSimpleTextImage_h
#define CKCoreButtonSimpleTextImage_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

typedef void (^CKCoreButtonSimpleTextImageCallback) (id sender);

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreButtonSimpleTextImage: UIButton

@property (nonatomic) NSColor                     *colorUnselectedText;
@property (nonatomic) NSColor                     *colorSelectedText;
@property (nonatomic) NSColor                     *colorDisabledText;
@property (nonatomic) NSColor                     *colorUnselectedBackground;
@property (nonatomic) NSColor                     *colorSelectedBackground;
@property (nonatomic) NSColor                     *colorDisabledBackground;
@property (nonatomic) NSColor                     *colorUnselectedBorder;
@property (nonatomic) NSColor                     *colorSelectedBorder;
@property (nonatomic) NSColor                     *colorDisabledBorder;
@property (nonatomic) NSImage                     *imageSelected;
@property (nonatomic) NSImage                     *imageUnselected;
@property (nonatomic) NSString                    *textSelected;
@property (nonatomic) NSString                    *textUnselected;
@property (nonatomic) Boolean                      imageOnRightSide;
@property (nonatomic) Boolean                      rounded;
@property (nonatomic) CGFloat                      onReleaseExpandBy;
@property (nonatomic) Boolean                      disableIfNoNetwork;
@property (nonatomic) Boolean                      popHighlight;

- (void) onTouchUpInside:(CKCoreButtonSimpleTextImageCallback) completionBlock;
- (void) onRelease:(void (^)(void)) completionBlock;
- (void) cleanUp;

@end

#endif


