#ifndef CKCoreCamera_h
#define CKCoreCamera_h

#import <Foundation/Foundation.h>
#import <AVFoundation/AVFoundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
typedef void (^CKCoreCameraPhotoCaptureCallback)(UIImage *);

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreCameraPhotoCapture : UIView

@property (nonatomic, readonly,getter = isFlashOn) Boolean flashON;
@property (nonatomic, strong) UIView                      *viewOverlay;
@property (nonatomic) AVCaptureVideoPreviewLayer          *videoPreviewLayer;

- (Boolean) currentCameraHasFlash;
- (void)    startRunning;
- (void)    stopRunning;
- (void)    toggleFlash;
- (void)    switchCamera;
- (void)    takePhoto:(CKCoreCameraPhotoCaptureCallback) onCompletion;
- (void)    focusAtPoint:(CGPoint) atPoint;

+ (Boolean) isBackCameraAvailable;
+ (Boolean) isFrontCameraAvailable;

@end

#endif

