#ifndef CKCoreFileUploader_h
#define CKCoreFileUploader_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

typedef void(^CKCoreFileUploaderCompletionBlock)(NSURLResponse *response, NSError *error, NSTimeInterval delay);
typedef void(^CKCoreFileUploaderProgressBlock)(CGFloat percentDone, CGFloat remainingTime);
typedef void(^CKCoreFileUploaderCancelBlock)(void);

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreFileUploaderTask: NSObject

- (void) cleanUp;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreFileUploader: NSObject <NSURLSessionTaskDelegate>

- (void)                       cleanUp;
- (void)                       cancelUpload:(CKCoreFileUploaderTask *) withTask;
- (void)                       clearUpload:(CKCoreFileUploaderTask *) withTask;
- (void)                       clearUploads:(NSArray <CKCoreFileUploaderTask *> *) withTasks;
- (void)                       clearAllUploads;
- (CKCoreFileUploaderTask *)   uploadFile:(NSURL *) withSourceURL withTargetURL:(NSURL *) withTargetURL withCompletionBlock:(CKCoreFileUploaderCompletionBlock) withCompletionBlock withProgressBlock:(CKCoreFileUploaderProgressBlock) withProgressBlock withCancelBlock:(CKCoreFileUploaderCancelBlock) withCancelBlock;
- (void)                       uploadFiles:(NSArray<NSURL *> *) withSourceURLs withTargetURLs:(NSArray<NSURL *> *) withTargetURLs
                       withCompletionBlock:(void (^)(Boolean isSuccess, NSError *error, CGFloat requestDuration)) withCompletionBlock
                         withProgressBlock:(void (^)(NSInteger fileInProgress, CGFloat percentDone, CGFloat remainingTime)) withProgressBlock
                           withCancelBlock:(void (^)(void)) withCancelBlock;

@end

#endif

