#ifndef CKCoreGlassMorphismView_h
#define CKCoreGlassMorphismView_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

typedef NS_ENUM(NSInteger, eCKCoreGlassMorphismViewTheme)
  {
  CKCoreGlassMorphismViewThemeLight,
  CKCoreGlassMorphismViewThemeDark,
  };

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreGlassMorphismView: NSView

@property (nonatomic) eCKCoreGlassMorphismViewTheme theme;
@property (nonatomic) CGFloat                       blurDensity;
@property (nonatomic) CGFloat                       cornerRadius;
@property (nonatomic) CGFloat                       distance;
@property (nonatomic) NSColor                      *glassTint;

- (void) makeGlassmorphismEffect:(eCKCoreGlassMorphismViewTheme) withTheme withDensity:(CGFloat) withDensity withCornerRadius:(CGFloat) withCornerRadius withDistance:(CGFloat) withDistance;

@end

#endif

