#ifndef CKCoreNSLabel_h
#define CKCoreNSLabel_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSLabel (Size)

- (void) adjustHeightToContent;
- (void) adjustHeightToContent:(CGFloat) withGap;
- (void) adjustWidthToContent;
- (void) adjustWidthToContent:(CGFloat) withGap;
- (void) adjustToContent;
- (void) adjustToContent:(CGFloat) withGap;
- (void) adjustToContent:(CGFloat) withXGap withYGap:(CGFloat) withYGap;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSLabel (Text)

- (void) setTextAtCenter:(NSString *_Nullable) withText withColor:(NSColor *_Nullable) withColor withFont:(UIFont *_Nullable) withFont;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSLabel (Blur)

- (void) blurWithRadius:(CGFloat) withRadius;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSLabel (Font)

- (void) scaleFontToPercent:(CGFloat) withFontSize withPercent:(CGFloat) withPercent;

@end

#endif

