#ifndef CKCoreNSMutableArray_h
#define CKCoreNSMutableArray_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreNSMutableArray

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSMutableArray (Generate)

+ (NSMutableArray *) generateArrayFromIntegerRange:(NSInteger) start to:(NSInteger) stop step:(NSInteger) step;
+ (NSMutableArray *) generateArrayFromFloatArray:(float *) floatArray count:(NSInteger) count;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSMutableArray (Sort)

- (void) sortByStringDescending;
- (void) sortByStringAscending;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSMutableArray (Values)

- (void) fillFromIndex:(NSInteger) fromIndex toIndex:(NSInteger) toIndex withObject:(id) withObject;
- (void) fillFromIndex:(NSInteger) fromIndex withObject:(id) withObject;
- (void) fillToIndex:(NSInteger) toIndex withObject:(id) withObject;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSMutableArray (Search)

- (NSArray <NSDictionary *> *) searchByKeyName:(NSString *) withKeyName withIntegerValue:(NSInteger) withIntegerValue;
- (NSArray <NSDictionary *> *) searchByKeyName:(NSString *) withKeyName withStringValue:(NSString *) withStringValue;
- (NSArray <NSDictionary *> *) searchByKeyName:(NSString *) withKeyName withBooleanValue:(Boolean) withBooleanValue;

@end

#endif

