#ifndef CKCoreOptionsListItem_h
#define CKCoreOptionsListItem_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreOptionsListItem : UIView

@property (nonatomic, strong) UIColor                           *optionBackgroundColor;
@property (nonatomic, strong) NSString                          *optionTitle;
@property (nonatomic, strong) UIFont                            *optionTitleFont;
@property (nonatomic, strong) UIColor                           *optionTitleColor;
@property (nonatomic, strong) NSString                          *optionDesc;
@property (nonatomic, strong) UIFont                            *optionDescFont;
@property (nonatomic, strong) UIColor                           *optionDescColor;
@property (nonatomic, strong) NSImage                           *optionImage;
@property (nonatomic) Boolean                                    optionHasImage;
@property (nonatomic, assign) CGFloat                            optionCornerRadius;
@property (nonatomic, assign) CGFloat                            verticalPadding;
@property (nonatomic) Boolean                                    optionEnabled;

- (instancetype) initWithTitle:(NSString *) title description:(NSString *) description image:(NSImage *) image;
- (void)         constructViewWithMaximumWidth:(NSNumber *) maxAllowedWidth;

@end

#endif

