#ifndef CKCoreSceneRequestHeadingAccess_h
#define CKCoreSceneRequestHeadingAccess_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #import <CodKits_macOS/CodKits_macOS.h>
#else
  #import <CodKits_iOS/CodKits_iOS.h>
#endif

@class CKCoreGlassMorphismView;
@class CKCoreButtonSimpleTextImage;

typedef NS_ENUM(NSInteger, CKCoreSceneRequestHeadingAccessResult)
  {
  CKCoreSceneRequestHeadingAccessGranted      = 0,
  CKCoreSceneRequestHeadingAccessIgnored      = 1,
  CKCoreSceneRequestHeadingAccessCancelled    = 2,
  CKCoreSceneRequestHeadingAccessNotSupported = 3,
  };

//-------------------------------------------------------------------------------------------------------------------------
// TYPEDEFS
//-------------------------------------------------------------------------------------------------------------------------
typedef void (^CKCoreSceneRequestHeadingAccessCallback) (CKCoreSceneRequestHeadingAccessResult result);

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreSceneRequestHeadingAccess: UIImageView

@property (nonatomic) CKCoreGlassMorphismView               *objPopupView;
@property (nonatomic) Boolean                                allowCancellation;
@property (nonatomic) UILabel                               *objTitle;
@property (nonatomic) UILabel                               *objInstructions;
@property (nonatomic) UIImageView                           *objImage;
@property (nonatomic) CKCoreButtonSimpleTextImage           *objNextKey;
@property (nonatomic) CKCoreButtonSimpleTextImage           *objIgnoreKey;
@property (nonatomic) NSString                              *textTitle;
@property (nonatomic) NSString                              *textAuthorizeKey;
@property (nonatomic) NSString                              *textOpenSettingsKey;
@property (nonatomic) NSString                              *textIgnoreKey;
@property (nonatomic) NSString                              *textMessage1;
@property (nonatomic) NSString                              *textMessage2;
@property (nonatomic) NSString                              *textMessage3;
@property (nonatomic) NSString                              *textMessage4;

- (void) checkForAuthorization:(CKCoreSceneRequestHeadingAccessCallback) completionBlock;

@end

#endif

