#ifndef CKCoreSoundsPlay_h
#define CKCoreSoundsPlay_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// PROTOCOL
//-------------------------------------------------------------------------------------------------------------------------
@protocol CKCoreSoundsPlayDelegate <NSObject>

@optional
- (void) CKCoreSoundsPlayDone:(Boolean) isSuccess;

@end

//-------------------------------------------------------------------------------------------------------------------------
#pragma mark - INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreSoundsPlay: NSObject

@property (weak, nonatomic) id<CKCoreSoundsPlayDelegate> delegate;

- (id)   initWithSounds:(NSArray <NSURL *> *) withUrls;
- (void) play:(void (^)(void)) completionBlock;
- (void) cleanUp;

@end

#endif

