#ifndef CKCoreSpeechRecognition_h
#define CKCoreSpeechRecognition_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #import <CodKits_macOS/CodKits_macOS.h>
#else
  #import <CodKits_iOS/CodKits_iOS.h>
#endif

NS_ASSUME_NONNULL_BEGIN

//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreSpeechRecognition : NSObject

@property (nonatomic) id               delegate;
@property (nonatomic) SEL              onSpeechPause;
@property (nonatomic) SEL              onSpeechStart;
@property (nonatomic) SEL              onSpeechTextUpdate;
@property (nonatomic) Boolean          speechRecognizerLocally;
@property (nonatomic) CGFloat          peakPowerForChannel0;
@property (nonatomic) CGFloat          peakPowerForChannel1;
@property (nonatomic) CGFloat          averagePowerForChannel0;
@property (nonatomic) CGFloat          averagePowerForChannel1;
@property (nonatomic) NSString        *spokenText;
@property (nonatomic) Boolean          isSpeaking;

- (Boolean) initSpeech:(NSString *) withLanguage;
- (Boolean) startSpeechCapture;
- (void)    endSpeechCapture;
- (void)    cleanUp;

@end

NS_ASSUME_NONNULL_END

#endif

