#ifndef CKCoreTagListItem_h
#define CKCoreTagListItem_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

typedef NS_ENUM(NSUInteger)
  {
  CKCoreTagListItemAccessoryViewNone = 0,
  CKCoreTagListItemAccessoryViewRemoveItem,
  CKCoreTagListItemAccessoryViewCustom
  } CKCoreTagListItemAccessoryView;


//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreTagListItem : UIView

@property (nonatomic, strong) NSString                      *tagName;
@property (nonatomic, strong) UIFont                        *tagFont;
@property (nonatomic, strong) UIColor                       *tagNameColor;
@property (nonatomic, strong) UIColor                       *tagBackgroundColor;
@property (nonatomic, assign) CGFloat                        tagCornerRadius;
@property (nonatomic, assign) CGFloat                        horizontalPadding;
@property (nonatomic, assign) CKCoreTagListItemAccessoryView accessoryView;
@property (nonatomic, assign) NSColor                       *accessoryViewColor;
@property (nonatomic, strong) UIView                        *customAccessoryView;
@property (nonatomic, assign) CGFloat                        customAccessoryViewPadding;

- (instancetype) initWithText:(NSString *) text;
- (void)         constructViewWithMaximumWidth:(NSNumber *) maxAllowedWidth;

@end

#endif

