#ifndef CKCoreAVAudioSession_h
#define CKCoreAVAudioSession_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

#import <AVFoundation/AVFoundation.h>

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreAVAudioSession

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface AVAudioSession (Extended)

+ (NSArray <AVAudioSessionPortDescription *> *)       listOfAvailableInputs;
+ (NSArray <AVAudioSessionPortDescription *> *)       listOfAvailableInputsWithChannelCount:(NSInteger) withChannelCount;
+ (NSArray <AVAudioSessionDataSourceDescription *> *) listOfDataSourcesForInput:(AVAudioSessionPortDescription *) withInput;
+ (NSArray <AVAudioSessionPortDescription *> *)       listOfAvailableInputsWithStereoChannels;
+ (AVAudioSessionDataSourceDescription *)             stereoDataSourceForPort:(AVAudioSessionPortDescription *) portDescription;

@end

#endif
