#ifndef CKCoreActionSheetMenu_h
#define CKCoreActionSheetMenu_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

NS_ASSUME_NONNULL_BEGIN

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreActionSheetMenuItem : NSObject

@property (nonatomic) id             userData;
@property (nonatomic) UIAlertAction *action;

- (instancetype) initWithCancel:(NSString *) withTitle completion:(void (^ __nullable)(CKCoreActionSheetMenuItem *)) completion;
- (instancetype) initWithDefault:(NSString *) withTitle completion:(void (^ __nullable)(CKCoreActionSheetMenuItem *)) completion;
- (instancetype) initWithDestructive:(NSString *) withTitle completion:(void (^ __nullable)(CKCoreActionSheetMenuItem *)) completion;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreActionSheetMenu : NSObject

- (instancetype) initWithTitle:(UIViewController *) onParentVC withTitle:(NSString *) withTitle withDescription:(NSString *) withDescription;
- (void)         addItem:(CKCoreActionSheetMenuItem *) newItem;
- (void)         showMenu:(Boolean) animated completion:(void (^ __nullable)(void)) completion;
- (void)         dismissMenu:(Boolean) animated completion:(void (^ __nullable)(void)) completion;

@end

NS_ASSUME_NONNULL_END

#endif

