#ifndef CKCoreActivityIndicatorView_h
#define CKCoreActivityIndicatorView_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

typedef NS_ENUM(NSUInteger, CKCoreActivityIndicatorAnimationType)
  {
  CKCoreActivityIndicatorAnimationTypeNineDots,
  CKCoreActivityIndicatorAnimationTypeTriplePulse,
  CKCoreActivityIndicatorAnimationTypeFiveDots,
  CKCoreActivityIndicatorAnimationTypeRotatingSquares,
  CKCoreActivityIndicatorAnimationTypeDoubleBounce,
  CKCoreActivityIndicatorAnimationTypeTwoDots,
  CKCoreActivityIndicatorAnimationTypeThreeDots,
  CKCoreActivityIndicatorAnimationTypeBallPulse,
  CKCoreActivityIndicatorAnimationTypeBallClipRotate,
  CKCoreActivityIndicatorAnimationTypeBallClipRotatePulse,
  CKCoreActivityIndicatorAnimationTypeBallClipRotateMultiple,
  CKCoreActivityIndicatorAnimationTypeBallRotate,
  CKCoreActivityIndicatorAnimationTypeBallZigZag,
  CKCoreActivityIndicatorAnimationTypeBallZigZagDeflect,
  CKCoreActivityIndicatorAnimationTypeBallTrianglePath,
  CKCoreActivityIndicatorAnimationTypeBallScale,
  CKCoreActivityIndicatorAnimationTypeLineScale,
  CKCoreActivityIndicatorAnimationTypeLineScaleParty,
  CKCoreActivityIndicatorAnimationTypeBallScaleMultiple,
  CKCoreActivityIndicatorAnimationTypeBallPulseSync,
  CKCoreActivityIndicatorAnimationTypeBallBeat,
  CKCoreActivityIndicatorAnimationTypeLineScalePulseOut,
  CKCoreActivityIndicatorAnimationTypeLineScalePulseOutRapid,
  CKCoreActivityIndicatorAnimationTypeBallScaleRipple,
  CKCoreActivityIndicatorAnimationTypeBallScaleRippleMultiple,
  CKCoreActivityIndicatorAnimationTypeTriangleSkewSpin,
  CKCoreActivityIndicatorAnimationTypeBallGridBeat,
  CKCoreActivityIndicatorAnimationTypeBallGridPulse,
  CKCoreActivityIndicatorAnimationTypeRotatingSandglass,
  CKCoreActivityIndicatorAnimationTypeRotatingTrigons,
  CKCoreActivityIndicatorAnimationTypeTripleRings,
  CKCoreActivityIndicatorAnimationTypeCookieTerminator
  };

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreActivityIndicatorView : UIView

- (id) initWithType:(CKCoreActivityIndicatorAnimationType) type;
- (id) initWithType:(CKCoreActivityIndicatorAnimationType) type tintColor:(UIColor *) tintColor;
- (id) initWithType:(CKCoreActivityIndicatorAnimationType) type tintColor:(UIColor *) tintColor size:(CGFloat) size;

@property (nonatomic) CKCoreActivityIndicatorAnimationType type;
@property (nonatomic, strong) UIColor                     *tintColor;
@property (nonatomic) CGFloat                              size;
@property (nonatomic, readonly) BOOL                       animating;

- (void) startAnimating;
- (void) stopAnimating;

@end

#endif

