#ifndef CKCoreAppleMusicLibrary_h
#define CKCoreAppleMusicLibrary_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

#import <MediaPlayer/MediaPlayer.h>

typedef void (^CKCoreAppleMusicLibraryItems)(MPMediaItemCollection *items);

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreAppleMusicLibrary: NSObject

+ (NSArray <NSDictionary *> *) playlistListOf;
+ (NSArray <NSDictionary *> *) playlistListOfSongs:(NSInteger) persistentID;
+ (MPMediaItemCollection *)    playlistByPersistentID:(NSInteger) persistentID;
+ (void)                       playlistCreateByName:(NSString *) withName withDescription:(NSString *) withDescription withAuthorName:(NSString *) withAuthorName completionBlock:(void (^)(MPMediaPlaylist *playlist, NSError *error)) completionBlock;

@end

#endif

