#ifndef CKCoreAppleMusicQuery_h
#define CKCoreAppleMusicQuery_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

#import <MediaPlayer/MediaPlayer.h>

NS_ASSUME_NONNULL_BEGIN

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreAppleMusicQuery: NSObject

@property (nonatomic) NSString           *customUrl;

- (NSURLSessionDataTask *) search:(NSDictionary *) withCriterias completionBlock:(void (^)(NSArray <NSDictionary *> *searchResults, NSError * _Nullable error, NSInteger statusCode)) completionBlock;
- (NSURLSessionDataTask *) lookup:(NSDictionary *) withCriterias completionBlock:(void (^)(NSArray <NSDictionary *> *searchResults, NSError * _Nullable error, NSInteger statusCode)) completionBlock;
- (void)                   lookupMany:(NSArray <NSDictionary *> *) withCriteriasList completionBlock:(void (^)(NSArray <NSDictionary *> *searchResults, NSError * _Nullable error, NSInteger statusCode)) completionBlock taskCompletionBlock:(void (^)(NSString *server, NSInteger remainingCount)) taskCompletionBlock;
- (void)                   cleanUp;

@end

NS_ASSUME_NONNULL_END

#endif

