#ifndef CKCoreCircularStepSlider_h
#define CKCoreCircularStepSlider_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreCircularStepSlider: UIControl

typedef NS_ENUM(NSInteger, eCKCoreCircularStepSliderHandleType)
  {
  CKCoreCircularStepSliderSemiTransparentWhiteCircle,
  CKCoreCircularStepSliderSemiTransparentBlackCircle,
  CKCoreCircularStepSliderDoubleCircleWithOpenCenter,
  CKCoreCircularStepSliderDoubleCircleWithClosedCenter,
  CKCoreCircularStepSliderBigCircle
  };

@property (nonatomic) float                               minimumValue;
@property (nonatomic) float                               maximumValue;
@property (nonatomic) float                               currentValue;

@property (nonatomic) int                                 lineWidth;
@property (nonatomic) int                                 lineRadiusDisplacement;
@property (nonatomic, strong) UIColor                    *filledColor;
@property (nonatomic, strong) UIColor                    *unfilledColor;

@property (nonatomic, strong) UIColor                    *handleColor;
@property (nonatomic) eCKCoreCircularStepSliderHandleType handleType;

@property (nonatomic, strong) UIFont                     *labelFont;
@property (nonatomic, strong) UIColor                    *labelColor;
@property (nonatomic, assign) NSInteger                   labelDisplacement;
@property (nonatomic) BOOL                                snapToLabels;

- (void) setInnerMarkingLabels:(NSArray *) labels;

@end

#endif

