#ifndef CKCoreDashedLine_h
#define CKCoreDashedLine_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

typedef NS_ENUM(NSInteger, CKCoreDashedLineEndType)
  {
  CKCoreDashedLineEndTypeNone,
  CKCoreDashedLineEndTypeCircle,
  CKCoreDashedLineEndTypeSquare,
  };

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreDashedLine : UIView

@property (nonatomic, assign) CGFloat                 lineThickness;
@property (nonatomic, copy) UIColor                  *lineColor;
@property (nonatomic, assign) CGFloat                 lineDashedLength;
@property (nonatomic, assign) CGFloat                 lineDashedGap;
@property (nonatomic, assign) CGPoint                 fromPoint;
@property (nonatomic, assign) CGPoint                 toPoint;
@property (nonatomic, assign) CKCoreDashedLineEndType endPoint;
@property (nonatomic, assign) CGFloat                 endPointRadius;

@end

#endif

