#ifndef CKCoreInAppPurchase_h
#define CKCoreInAppPurchase_h

#import <Foundation/Foundation.h>
#import <StoreKit/StoreKit.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

typedef enum
  {
  CKCore_PurchaseStatusInProgress = 1,
  CKCore_PurchaseStatusCompleted,
  CKCore_PurchaseStatusRestored,
  CCCore_PurchaseStatusPurchaseFailed,
  CCCore_PurchaseStatusRestoreFailed,
  CKCore_PurchaseStatusCancelled,
  } CKCoreInAppPurchaseStatus;

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreInAppPurchase: NSObject

@property (nonatomic) id                            delegate;
@property (nonatomic) NSArray                      *validProducts;
@property (nonatomic) SEL                           onProcessComplete;
@property (nonatomic) SEL                           onProcessInProgress;
@property (nonatomic) SEL                           onProcessStart;
@property (nonatomic) SEL                           onProcessStop;
@property (nonatomic) SEL                           onAvailableProducts;
@property (nonatomic) Boolean                       canMakePurchases;

- (void) fetchAvailableProducts:(NSArray *) idArray;
- (void) purchaseOneProduct:(SKProduct *) product;
- (void) purchase;
- (void) restorePurchase;
- (void) cleanUp;

@end

#endif

