#ifndef CKCoreKeychain_h
#define CKCoreKeychain_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreKeychain : NSObject

+ (BOOL)                                      valueForServiceExist:(NSString *) serviceName account:(NSString *) account;
+ (NSString *)                                passwordForService:(NSString *) serviceName account:(NSString *) account;
+ (NSString *)                                passwordForService:(NSString *) serviceName account:(NSString *) account error:(NSError **) error;
+ (NSData *)                                  passwordDataForService:(NSString *) serviceName account:(NSString *) account;
+ (NSData *)                                  passwordDataForService:(NSString *) serviceName account:(NSString *) account error:(NSError **) error;
+ (BOOL)                                      deletePasswordForService:(NSString *) serviceName account:(NSString *) account;
+ (BOOL)                                      deletePasswordForService:(NSString *) serviceName account:(NSString *) account error:(NSError **) error;
+ (BOOL)                                      setPassword:(NSString *) password forService:(NSString *) serviceName account:(NSString *) account;
+ (BOOL)                                      setPassword:(NSString *) password forService:(NSString *) serviceName account:(NSString *) account error:(NSError **) error;
+ (BOOL)                                      setPasswordData:(NSData *) password forService:(NSString *) serviceName account:(NSString *) account;
+ (BOOL)                                      setPasswordData:(NSData *) password forService:(NSString *) serviceName account:(NSString *) account error:(NSError **) error;
+ (NSArray<NSDictionary<NSString *, id> *> *) allAccounts;
+ (NSArray<NSDictionary<NSString *, id> *> *) allAccounts:(NSError **) error;
+ (NSArray<NSDictionary<NSString *, id> *> *) accountsForService:(NSString *) serviceName;
+ (NSArray<NSDictionary<NSString *, id> *> *) accountsForService:(NSString *) serviceName error:(NSError **) error;

@end

#endif

