#ifndef CKCoreLinearGaugeView_h
#define CKCoreLinearGaugeView_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreLinearGaugeView : UIView

@property (nonatomic) NSColor                    *colorProgressStart;
@property (nonatomic) NSColor                    *colorProgressEnd;
@property (nonatomic) NSColor                    *colorProgressBackground;
@property (nonatomic) CGFloat                     colorProgressBackgroundAlpha;
@property (nonatomic) CGFloat                     maxValue;
@property (nonatomic) CGFloat                     shadowRadius;
@property (nonatomic) CGFloat                     shadowOpacity;
@property (nonatomic) CGFloat                     currentValue;
@property (nonatomic) CGFloat                     widthProgressLine;
@property (nonatomic) Boolean                     roundCap;
@property (nonatomic) Boolean                     reversed;

- (void) setCurrentValue:(CGFloat) value withAnimationDuration:(NSTimeInterval) withAnimationDuration completionBlock:(void (^)(void)) completionBlock;

@end

#endif

