#ifndef CKCoreMaths_h
#define CKCoreMaths_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//----------------------------------------------------------------------------------------------------
@interface CKCoreMaths: NSObject

+ (NSString *) toBinaryString:(NSUInteger) withNumber;
+ (float *)    reduce2DFloatArray:(float *) withSource withSourceWidth:(NSInteger) withSourceWidth withSourceHeight:(NSInteger) withSourceHeight withBlockSize:(NSInteger) withBlockSize;

@end

//----------------------------------------------------------------------------------------------------
@interface CKCoreMaths (Audio)

+ (CGFloat)        beat2Ms:(CGFloat) withBeat withBPM:(NSInteger) withBPM withNumerator:(NSInteger) withNumerator withDenominator:(NSInteger) withDenominator;
+ (double)         percentTodBSignal:(CGFloat) withPercent;
+ (double)         percentTodBPower:(CGFloat) withPercent;
+ (double)         dBToPercent:(CGFloat) withdB;
+ (CGFloat)        detectBestAudioProfileFromTimeEvents:(NSArray <NSNumber *> *) withTimeEvents offset:(CGFloat *) offset;
+ (NSDictionary *) detectBestAudioProfileMatchingTimeEvents:(NSArray <NSNumber *> *) withTimeEvents;

@end

//----------------------------------------------------------------------------------------------------
@interface CKCoreMaths (Video)

+ (CGSize) croppedSize:(CGSize) originalSize withFormatWidth:(CGFloat) withFormatWidth withFormatHeight:(CGFloat) withFormatHeight;

@end

#endif

