#ifndef CKCoreMorphingLabel_h
#define CKCoreMorphingLabel_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreMorphingLabel : UILabel

@property (readonly, atomic, strong) NSString                               *targetText;
@property (nonatomic, assign) IBInspectable CGFloat                          animationDuration;
@property (nonatomic, assign) IBInspectable CGFloat                          characterAnimationOffset;
@property (nonatomic, assign) IBInspectable CGFloat                          characterShrinkFactor;
@property (nonatomic, assign, getter = isMorphingEnabled) IBInspectable BOOL morphingEnabled;

- (void) setTextWithoutMorphing:(NSString *) text;
- (void) setText:(NSString *) text withCompletionBlock:(void (^)(void)) block;

@end

#endif

