#ifndef CKCoreMotionFitness_h
#define CKCoreMotionFitness_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

#import <CoreMotion/CoreMotion.h>

typedef NS_ENUM(NSInteger, CKCoreMotionFitnessAuthorization)
  {
  CKCoreMotionFitnessAuthorized            = 0,
  CKCoreMotionFitnessDenied                = 1,
  CKCoreMotionFitnessRequest               = 2,
  };

//-------------------------------------------------------------------------------------------------------------------------
// PROTOCOL
//-------------------------------------------------------------------------------------------------------------------------
@protocol CKCoreMotionFitnessDelegate <NSObject>

@optional
- (void) CKCoreMotionFitnessAuthorizationChanged:(CKCoreMotionFitnessAuthorization) status;
- (void) CKCoreMotionFitnessChanged:(CMMotionActivity *) newActivity;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreMotionFitness: NSObject

@property (nonatomic) id<CKCoreMotionFitnessDelegate> delegate;
@property (nonatomic) Boolean                         isMotionAvailable;

- (CKCoreMotionFitnessAuthorization) isAuthorized;
- (void)                             cleanUp;
- (void)                             queryActivity:(NSDate *) fromDate toDate:(NSDate *) toDate completionBlock:(void (^)(NSArray<CMMotionActivity *> *activities, NSError *error)) completionBlock;

@end

#endif 
