#ifndef CKCoreNSArray_h
#define CKCoreNSArray_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreNSArray

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSArray (Generate)

+ (NSArray *)  generateArrayFromIntegerRange:(NSInteger) start to:(NSInteger) stop step:(NSInteger) step;
+ (NSArray *)  generateArrayFromDictionaryArray:(NSArray *) withArray withKey:(NSString *) withKey;
+ (NSString *) generateStringFromArray:(NSArray *) withArray;
+ (NSString *) generateStringFromArray:(NSArray *) withArray withSeparator:(NSString *) withSeparator;
+ (NSArray *)  arrayWithString:(NSString *) withString withSize:(NSInteger) withSize;
+ (NSArray *)  arrayFromBundlePList:(NSString *) withPList;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSArray (Sort)

+ (NSArray *) commonElements:(NSArray *) withArrayA withArrayB:(NSArray *) withArrayB;
+ (NSArray *) filterByUniqueStrings:(NSArray *) withArray;
+ (NSArray *) randomize:(NSArray *) withArray;
+ (NSArray *) sortAlphabetically:(NSArray *) withArray;

- (NSArray *) reverse;
- (id)        secondObject;

@end

//----------------------------------------------------------------------------------------------------
@interface NSArray (Extended)

- (void) removeFromSuperview;

@end

//----------------------------------------------------------------------------------------------------
@interface NSArray (Values)

+ (NSInteger) countBooleanValues:(NSArray *) withArray withBooleanValue:(Boolean) withBooleanValue;

@end

#endif

