#ifndef CKCoreNSDate_h
#define CKCoreNSDate_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreNSDate

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSDate (Extended)

- (Boolean)    olderThanDays:(NSInteger) days;
- (Boolean)    olderThanDate:(NSDate *) withDate;
- (NSString *) toLongDateString;
- (NSString *) toLongDateTimeString;
- (NSInteger)  toUnixTime;
- (NSString *) toISO8601;
- (NSInteger)  year;
- (NSInteger)  month;
- (NSInteger)  day;
- (Boolean)    isBetweenDate:(NSDate *) beginDate andDate:(NSDate *) endDate;
- (Boolean)    isToday;
- (Boolean)    isYesterday;
- (Boolean)    isTomorrow;
- (NSDate *)   dateByAddingDays:(NSTimeInterval) withDays;
- (NSDate *)   dateByAddingHours:(NSTimeInterval) withHours;
- (NSDate *)   dateByAddingSeconds:(NSTimeInterval) withSeconds;

+ (NSDate *)  dateWithComponents:(NSInteger) year month:(NSInteger) month day:(NSInteger) day hour:(NSInteger) hour minute:(NSInteger) minute second:(NSInteger) second;
+ (NSDate *)  dateWithComponents:(NSInteger) year month:(NSInteger) month day:(NSInteger) day;
+ (NSDate *)  dateNow;
+ (NSDate *)  dateByAddingSeconds:(NSTimeInterval) withSeconds;
+ (NSDate *)  dateByAddingDays:(NSTimeInterval) withDays;
+ (NSDate *)  dateByAddingHours:(NSTimeInterval) withHours;
+ (NSDate *)  dateByAddingSecondsToDate:(NSDate *) withDate withSeconds:(NSTimeInterval) withSeconds;
+ (NSInteger) weekOfYear;
+ (NSInteger) quarter;
+ (NSInteger) second;
+ (NSInteger) minute;
+ (NSInteger) hour;
+ (NSInteger) era;
+ (NSInteger) weekOfMonth;
+ (NSInteger) weekDay;
+ (NSInteger) day;
+ (NSInteger) month;
+ (NSInteger) year;

@end

#endif

