#ifndef CKCoreNSFont_h
#define CKCoreNSFont_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSFont (Enumerate)

+ (NSArray <NSString *> *) listOfAvailableFonts;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSFont (CustomLoader)

+ (UIFont *)  customFontOfSize:(CGFloat) size withName:(NSString *) name withExtension:(NSString *) extension;
+ (UIFont *)  customFontWithURL:(NSURL *) fontURL size:(CGFloat) size;
+ (NSArray *) registerFontFromURL:(NSURL *) fontURL;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface NSFont (FamilyNames)

+ (NSFont *) arialWithSize:(CGFloat) withSize;
+ (NSFont *) arialBoldWithSize:(CGFloat) withSize;
+ (NSFont *) arialItalicWithSize:(CGFloat) withSize;
+ (NSFont *) arialBoldItalicWithSize:(CGFloat) withSize;
+ (NSFont *) avenirNextWithSize:(CGFloat) withSize;
+ (NSFont *) avenirNextBoldWithSize:(CGFloat) withSize;
+ (NSFont *) avenirNextItalicWithSize:(CGFloat) withSize;
+ (NSFont *) avenirNextBoldItalicWithSize:(CGFloat) withSize;

@end

#endif

