#ifndef CKCoreOptionsList_h
#define CKCoreOptionsList_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

@class CKCoreOptionsList;
@class CKCoreOptionsListItem;

//-------------------------------------------------------------------------------------------------------------------------
// PROTOCOL
//-------------------------------------------------------------------------------------------------------------------------
@protocol CKCoreOptionsListDataSource <NSObject>

@required
- (NSUInteger)              numberOfItemsInOptionList:(CKCoreOptionsList *) optionList;
- (CKCoreOptionsListItem *) optionList:(CKCoreOptionsList *) optionList optionItemAtIndex:(NSUInteger) optionItemIndex;

@optional
- (CGFloat) heightForAllItemsInOptionList:(CKCoreOptionsList *) optionList;
- (CGFloat) verticalSpaceBetweenItemsInOptionList:(CKCoreOptionsList *) optionList;

@end

//-------------------------------------------------------------------------------------------------------------------------
// PROTOCOL
//-------------------------------------------------------------------------------------------------------------------------
@protocol CKCoreOptionsListDelegate <NSObject>

@optional
- (void) optionList:(CKCoreOptionsList *) optionList itemTappedAtIndex:(NSUInteger) optionItemIndex;
- (void) optionList:(CKCoreOptionsList *) optionList itemAccessoryButtonTappedAtIndex:(NSUInteger) optionItemIndex;
- (void) optionList:(CKCoreOptionsList *) optionList requestedTagListItemRemovalAtIndex:(NSUInteger) optionItemIndex;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreOptionsList : UIView

@property (nonatomic, weak) id <CKCoreOptionsListDataSource> dataSource;
@property (nonatomic, weak) id <CKCoreOptionsListDelegate>   delegate;
@property (nonatomic, strong) UIView                        *optionListHeaderView;
@property (nonatomic, strong) UIView                        *optionListFooterView;
@property (nonatomic) Boolean                                optionPopOnSelection;
@property (nonatomic) Boolean                                optionHasImage;

- (CKCoreOptionsListItem *) optionItemAtIndex:(NSUInteger) optionIndex;
- (void)                    reloadData;

@end

#endif

