#ifndef CKCoreScreenMetrics_h
#define CKCoreScreenMetrics_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreScreenMetrics: NSObject

@property (nonatomic, readonly) CGFloat           ratioWidth;
@property (nonatomic, readonly) CGFloat           ratioHeight;

- (id)      initWithDeviceRefModel:(NSInteger) withModel;
- (CGFloat) adjustedFontSize:(CGFloat) size;
- (CGFloat) adjustedFontSize:(CGFloat) size withMinSize:(CGFloat) withMinSize;
- (CGSize)  adjustedSize:(CGSize) size;
- (CGSize)  adjustedSize:(CGSize) size withMinSize:(CGSize) withMinSize;
- (CGSize)  adjustedSquareSize:(CGSize) size;
- (CGSize)  adjustedSquareSize:(CGSize) size withMinSize:(CGSize) withMinSize;
- (CGRect)  adjustedRect:(CGRect) frame;
- (CGRect)  adjustedRect:(CGRect) frame withMinRect:(CGRect) withMinRect;
- (CGFloat) adjustedHeight:(CGFloat) withHeight;
- (CGFloat) adjustedHeight:(CGFloat) withHeight withMinHeight:(CGFloat) withMinHeight;
- (CGFloat) adjustedWidth:(CGFloat) withWidth;
- (CGFloat) adjustedWidth:(CGFloat) withWidth withMinWidth:(CGFloat) withMinWidth;

- (void)    cleanUp;

@end

#endif


