#ifndef CKCoreSimpleTextFieldKeyboard_h
#define CKCoreSimpleTextFieldKeyboard_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #import <Cocoa/Cocoa.h>
#else
  #import <UIKit/UIKit.h>
#endif

@class CKCoreSimpleTextFieldKeyboard;

//-------------------------------------------------------------------------------------------------------------------------
// PROTOCOL
//-------------------------------------------------------------------------------------------------------------------------
@protocol CKCoreSimpleTextFieldKeyboardDelegate <NSObject>

@optional

- (void) escPressedInTextField:(CKCoreSimpleTextFieldKeyboard *) textField;
- (void) enterPressedInTextField:(CKCoreSimpleTextFieldKeyboard *) textField;

@end

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreSimpleTextFieldKeyboard : UITextField

@property (nonatomic, weak) id<CKCoreSimpleTextFieldKeyboardDelegate> keyboardDelegate;

- (void) internalEscPressed;
- (void) internalEnterPressed;

@end

#endif

