#ifndef CKCoreView_h
#define CKCoreView_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #include <CodKits_macOS/CodKits_macOS.h>
#else
  #include <CodKits_iOS/CodKits_iOS.h>
#endif

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreView: NSView

@property (nonatomic) id                                    delegate;
@property (nonatomic) SEL                                   onMouseRightClick;
@property (nonatomic) SEL                                   onMouseDown;
@property (nonatomic) SEL                                   onMouseUp;
@property (nonatomic) SEL                                   onScrollWheel;

@property (nonatomic) CGFloat                               gradientAngle;
@property (nonatomic) NSArray <NSColor *>                  *gradientColors;
@property (nonatomic) NSArray <NSValue *>                  *gradientLocations;

@property (nonatomic) CGFloat                               borderWidth;
@property (nonatomic) NSColor                              *borderColor;
@property (nonatomic) CGFloat                               cornerRadius;
@property (nonatomic) NSArray <NSNumber *>                 *cornersRadius;

@property (nonatomic) CGSize                                shadowOffset;
@property (nonatomic) NSColor                              *shadowColor;
@property (nonatomic) CGFloat                               shadowRadius;

@property (nonatomic) NSColor                              *backgroundColor;
@property (nonatomic) NSImage                              *backgroundImage;
@property (nonatomic) NSColor                              *backgroundImageTint;
@property (nonatomic) CGFloat                               backgroundImageScaleFactor;

@property (nonatomic) NSColor                              *backgroundTextColor;
@property (nonatomic) NSFont                               *backgroundTextFont;
@property (nonatomic) NSString                             *backgroundText;
@property (nonatomic) NSTextAlignment                       backgroundTextAlignment;

@property (nonatomic) id                                    userData;

//@property (nonatomic) NSColor                              *backgroundColor;
//
//@property (nonatomic) CGFloat                               gradientAngle;
//@property (nonatomic) NSArray <id>                         *gradientColors;
//@property (nonatomic) NSArray <NSNumber *>                 *gradientLocations;
//@property (nonatomic) CGPoint                               gradientStart;
//@property (nonatomic) CGPoint                               gradientEnd;
//
//@property (nonatomic) CGSize                                shadowOffset;
//
//@property (nonatomic) NSColor                              *borderColor;
//@property (nonatomic) CGFloat                               borderWidth;
//
//@property (nonatomic) CGFloat                               cornerRadius;
//@property (nonatomic) NSArray <NSNumber *>                 *cornersRadius;
//
//@property (nonatomic) id                                    userData;

@end

#endif

