#ifndef CKCoreViewGradientAnimation_h
#define CKCoreViewGradientAnimation_h

#import <Foundation/Foundation.h>

#if TARGET_OS_OSX
  #import <CodKits_macOS/CodKits_macOS.h>
#else
  #import <CodKits_iOS/CodKits_iOS.h>
#endif

//----------------------------------------------------------------------------------------------------
typedef NS_ENUM(NSInteger, CKCoreViewGradientAnimationModel)
  {
  CKCoreViewGradientAnimationGreenBlue,
  CKCoreViewGradientAnimationOrangeYellow,
  CKCoreViewGradientAnimationBlueCyan,
  CKCoreViewGradientAnimationBluePink,
  CKCoreViewGradientAnimationRedBlue,
  CKCoreViewGradientAnimationRedOrange,
  CKCoreViewGradientAnimationYellowGreen,
  CKCoreViewGradientAnimationYellowOrangeRed,
  CKCoreViewGradientAnimationCyanPinkBlue,
  CKCoreViewGradientAnimationGreenOrangeBlack,
  CKCoreViewGradientAnimationCyanPinkRed,
  CKCoreViewGradientAnimationGreenYellowRed,
  CKCoreViewGradientAnimationBlackGrey,
  };

//-------------------------------------------------------------------------------------------------------------------------
// INTERFACE
//-------------------------------------------------------------------------------------------------------------------------
@interface CKCoreViewGradientAnimation: UIView

@property (nonatomic) CGPoint                             startGradientPoint;
@property (nonatomic) CGPoint                             endGradientPoint;
@property (nonatomic) NSTimeInterval                      animationDuration;
@property (nonatomic) NSArray <UIColor *>                *gradientColors;
@property (nonatomic) CKCoreViewGradientAnimationModel    gradientModel;

- (void) startAnimation;

@end

#endif
