#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>

//-------------------------------------------------------------------------------------------------------------------------
// DEFINES
//-------------------------------------------------------------------------------------------------------------------------
#define MAINTHREADBLOCKSTART        dispatch_async(dispatch_get_main_queue(), ^{
#define MAINTHREADBLOCKEND          });
#define BACKTHREADBLOCKSTART        dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
#define BACKTHREADBLOCKEND          });
#define AUTORELEASEPOOLSTART        @autoreleasepool {
#define AUTORELEASEPOOLEND          }
#define BACKTHREADHIGHBLOCKSTART    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_HIGH, 0), ^{
#define BACKTHREADHIGHBLOCKEND      });
#define BACKTHREADMAINQUEUESTART    [[NSOperationQueue mainQueue] addOperationWithBlock:^{
#define BACKTHREADMAINQUEUEEND      }];
#define MAINTHREADLOOP              [[NSRunLoop mainRunLoop] runUntilDate:[NSDate dateWithTimeIntervalSinceNow:.1]];
#define CURRENTTHREADLOOP           [[NSRunLoop currentRunLoop] runUntilDate:[NSDate dateWithTimeIntervalSinceNow:.1]];

#define RUNLOOPCLEAN \
  if ([NSRunLoop currentRunLoop] != [NSRunLoop mainRunLoop]) [[NSRunLoop currentRunLoop] runUntilDate:[NSDate date]];

#if !defined(StringOrEmpty)
  #define stringOrEmpty(A)  ({ __typeof__(A) __a = (A); __a ? __a : @""; })
#endif

#if !defined(degreesToRadians)
  #define degreesToRadians( degrees ) (degrees / 180.0 * M_PI)
#endif

#if !defined(radiansToDegrees)
  #define radiansToDegrees( radians ) (radians * 180.0 / M_PI)
#endif

#define SYNCHRONIZEGET(_Type, _NameGet) \
- (_Type) _NameGet { @synchronized(lock) { return self->_NameGet; } }

#define SYNCHRONIZE(_Type, _NameGet, _NameSet) \
- (_Type) _NameGet { @synchronized(lock) { return self->_NameGet; } } \
- (void) _NameSet:(_Type) value { @synchronized(lock) { self->_NameGet = value; } }

#define SYNCHRONIZESET(_Type, _NameGet, _NameSet) \
- (void) _NameSet:(_Type) value { @synchronized(lock) { self->_NameGet = value; } }

#if !defined(StringOrEmpty)
  #define StringOrEmpty(A)  ({ __typeof__(A) __a = (A); __a ? __a : @""; })
#endif

#if !defined(isEven)
  #define isEven(A)  (((NSInteger) A % 2) == 0)
  #define isOdd(A)   (((NSInteger) A % 2) != 0)
#endif

#define NSView       UIView
#define NSColor      UIColor
#define NSImage      UIImage
#define NSBezierPath UIBezierPath
#define NSTextField  UITextField
#define NSWindow     UIWindow
#define NSEdgeInsets UIEdgeInsets
#define NSImageView  UIImageView
#define NSButton     UIButton
#define NSLabel      UILabel
#define NSFont       UIFont

//-------------------------------------------------------------------------------------------------------------------------
// COMMON iOS / macOS
//-------------------------------------------------------------------------------------------------------------------------

//----- Framework -----
#include <CodKits_iOS/CKCoreFramework.h>

//----- NSString -----
#include <CodKits_iOS/CKCoreNSString.h>

//----- NSMutableString -----
#include <CodKits_iOS/CKCoreNSMutableString.h>

//----- NSMutableArray -----
#include <CodKits_iOS/CKCoreNSMutableArray.h>

//----- NSDictionary -----
#include <CodKits_iOS/CKCoreNSDictionary.h>

//----- NSData -----
#include <CodKits_iOS/CKCoreNSData.h>

//----- NSDate -----
#include <CodKits_iOS/CKCoreNSDate.h>

//----- NSArray -----
#include <CodKits_iOS/CKCoreNSArray.h>

//----- NSCoder -----
#include <CodKits_iOS/CKCoreNSCoder.h>

//----- NSObject -----
#include <CodKits_iOS/CKCoreNSObject.h>

//----- NSCalendar -----
#include <CodKits_iOS/CKCoreNSCalendar.h>

//----- NSCountedSet -----
#include <CodKits_iOS/CKCoreNSCountedSet.h>

//----- Credit Card -----
#include <CodKits_iOS/CKCoreCreditCardValidator.h>

//----- NSURL -----
#include <CodKits_iOS/CKCoreNSURL.h>

//----- NSValue -----
#include <CodKits_iOS/CKCoreNSValue.h>

//----- NSColor -----
#include <CodKits_iOS/CKCoreNSColor.h>
#include <CodKits_iOS/CKCoreColorScheme.h>

//----- Threading -----
#include <CodKits_iOS/CKCoreParallelProcessing.h>

//----- Notifications -----
#include <CodKits_iOS/CKCoreNotifications.h>

//----- Random -----
#include <CodKits_iOS/CKCoreRandom.h>

//----- Cryptography -----
#include <CodKits_iOS/CKCoreCryptography.h>

//----- Security -----
#include <CodKits_iOS/CKCoreKeychain.h>
#include <CodKits_iOS/CKCoreKeychainQuery.h>
#include <CodKits_iOS/CKCoreCredentialsStorage.h>
#include <CodKits_iOS/CKCorePasswordGenerator.h>
#include <CodKits_iOS/CKCorePasswordStrengthEvaluator.h>

//----- File System -----
#include <CodKits_iOS/CKCoreFileSystem.h>
#include <CodKits_iOS/CKCoreNumpy2DArray.h>
#include <CodKits_iOS/CKCoreCSVFile.h>

//----- Image -----
#include <CodKits_iOS/CKCoreCIFilters.h>
#include <CodKits_iOS/CKCoreImageVision.h>

//----- CGObjects -----
#include <CodKits_iOS/CKCoreCGUtilities.h>

//----- Maths -----
#include <CodKits_iOS/CKCoreMaths.h>

//----- vDSP -----
#include <CodKits_iOS/CKCorevDSP.h>

//----- Date Time -----
#include <CodKits_iOS/CKCoreDateTime.h>

//----- Number -----
#include <CodKits_iOS/CKCoreNumber.h>

//----- Resources -----
#include <CodKits_iOS/CKCoreResources.h>
#include <CodKits_iOS/CKCoreCountries.h>

//----- Camera -----
#include <CodKits_iOS/CKCoreQRCodeCapture.h>

//----- Timer -----
#include <CodKits_iOS/CKCoreTimer.h>
#include <CodKits_iOS/CKCoreTaskScheduler.h>
#include <CodKits_iOS/CKCoreExecutionTime.h>
#include <CodKits_iOS/CKCoreHighPrecisionTimer.h>

//----- Networking -----
#include <CodKits_iOS/CKCoreUrlDownloader.h>
#include <CodKits_iOS/CKCoreFileUploader.h>
#include <CodKits_iOS/CKCoreFileDownloader.h>
#include <CodKits_iOS/CKCoreNetworkCurl.h>
#include <CodKits_iOS/CKCoreNetworkMultipeer.h>

//----- Bluetooth BLE -----
#include <CodKits_iOS/CKCoreBLECentral.h>
#include <CodKits_iOS/CKCoreBLEPeripheral.h>
#include <CodKits_iOS/CKCoreBLEMyCharacteristic.h>

//----- AVObjects -----
#include <CodKits_iOS/CKCoreAVPlayerItem.h>
#include <CodKits_iOS/CKCoreAVAsset.h>
#include <CodKits_iOS/CKCoreAVAssetTrack.h>
#include <CodKits_iOS/CKCoreAVPlayer.h>
#include <CodKits_iOS/CKCoreAVPlayerLayer.h>
#include <CodKits_iOS/CKCoreAVAudioSession.h>

//----- CAObjects -----
#include <CodKits_iOS/CKCoreCALayer.h>

//----- Local Settings Storage -----
#include <CodKits_iOS/CKCoreSettingsStorage.h>

//----- TouchID -----
#include <CodKits_iOS/CKCoreTouchID.h>

//----- NSView -----
#include <CodKits_iOS/CKCoreNSView.h>
#include <CodKits_iOS/CKCoreAnimatedBorderView.h>
#include <CodKits_iOS/CKCoreVideoShowView.h>

//----- NSAttributedString -----
#include <CodKits_iOS/CKCoreNSAttributedString.h>

//----- Audio -----
#include <CodKits_iOS/CKCoreQuickSoundPlay.h>
#include <CodKits_iOS/CKCoreSoundPlay.h>
#include <CodKits_iOS/CKCoreSoundsPlay.h>
#include <CodKits_iOS/CKCoreAudioFile.h>
#include <CodKits_iOS/CKCoreAudioEnergyMap.h>
#include <CodKits_iOS/CKCoreAudioRMSLevels.h>
#include <CodKits_iOS/CKCoreAudioTools.h>
#include <CodKits_iOS/CKCoreAudioSpectrumView.h>
#include <CodKits_iOS/CKCoreAudioRecord.h>

//----- InApp Purchase -----
#include <CodKits_iOS/CKCoreInAppPurchase.h>

//----- Video -----
#include <CodKits_iOS/CKCoreVideoTools.h>

//----- NSImage -----
#include <CodKits_iOS/CKCoreQRCodeGenerator.h>

//----- NSImageView -----
#include <CodKits_iOS/CKCoreNSImageView.h>

//----- NSOperationQueue -----
#include <CodKits_iOS/CKCoreNSOperationQueue.h>

//----- Wrappers -----
#include <CodKits_iOS/CKCoreElevenLabs.h>
#include <CodKits_iOS/CKCoreOpenAI.h>
#include <CodKits_iOS/CKCoreCoinbase.h>
#include <CodKits_iOS/CKCoreDeepgram.h>
#include <CodKits_iOS/CKCoreAnthropic.h>
#include <CodKits_iOS/CKCoreOpenWeatherMap.h>

//----- Observers -----
#include <CodKits_iOS/CKCoreObserver.h>
#include <CodKits_iOS/CKCoreObserverDeallocator.h>
#include <CodKits_iOS/NSObject+Observing.h>

//-------------------------------------------------------------------------------------------------------------------------
// SPECIFIC iOS
//-------------------------------------------------------------------------------------------------------------------------

//----- Bridge Header -----
#include <CodKits_iOS/CodKits_iOS-Bridging-Header.h>

//----- System Info -----
#include <CodKits_iOS/CKCoreSystemInfo.h>

//----- Networking -----
#include <CodKits_iOS/CKCoreNetwork.h>

//----- NSImage -----
#include <CodKits_iOS/CKCoreNSImage.h>

//----- NSLabel -----
#include <CodKits_iOS/CKCoreNSLabel.h>

//----- Haptic -----
#include <CodKits_iOS/CKCoreHaptic.h>

//----- Animation -----
#include <CodKits_iOS/CKCoreViewAnimation.h>
#include <CodKits_iOS/CKCoreViewGradientAnimation.h>

//----- Camera -----
#include <CodKits_iOS/CKCoreCamera.h>

//----- Finder -----
#include <CodKits_iOS/CKCoreFinder.h>

//----- Torch -----
#include <CodKits_iOS/CKCoreTorch.h>

//----- NSFont -----
#include <CodKits_iOS/CKCoreNSFont.h>

//----- Custom NSView -----
#include <CodKits_iOS/CKCoreView.h>
#include <CodKits_iOS/CKCorePopupView.h>
#include <CodKits_iOS/NSView+Notification.h>
#include <CodKits_iOS/CKCoreGlassMorphismView.h>

//----- Widgets -----
#include <CodKits_iOS/CKCoreActivityIndicatorView.h>
#include <CodKits_iOS/CKCoreDashedLine.h>
#include <CodKits_iOS/CKCoreMorphingLabel.h>
#include <CodKits_iOS/CKCoreFadeInOutLabel.h>
#include <CodKits_iOS/CKCoreHorizontalLabelScroll.h>
#include <CodKits_iOS/CKCoreVerticalLabelScroll.h>
#include <CodKits_iOS/CKCoreButtonSimpleTextImage.h>
#include <CodKits_iOS/CKCoreButtonCamera.h>
#include <CodKits_iOS/CKCoreCircleMenuView.h>
#include <CodKits_iOS/CKCoreDotMatrixLabelFontMapping.h>
#include <CodKits_iOS/CKCoreDotMatrixLabel.h>
#include <CodKits_iOS/CKCoreSimpleTextField.h>
#include <CodKits_iOS/CKCoreFloatLabelTextField.h>
#include <CodKits_iOS/CKCoreCircularProgressBarView.h>
#include <CodKits_iOS/CKCoreCircularProgressBarLayer.h>
#include <CodKits_iOS/CKCoreCircularGaugeView.h>
#include <CodKits_iOS/CKCoreLinearGaugeView.h>
#include <CodKits_iOS/CKCoreCheckedBox.h>
#include <CodKits_iOS/CKCoreLinearStepSlider.h>
#include <CodKits_iOS/CKCoreCircularStepSlider.h>
#include <CodKits_iOS/CKCoreLinearRangeSlider.h>
#include <CodKits_iOS/CKCoreImageCarousel.h>
#include <CodKits_iOS/CKCoreImageCarouselReflection.h>
#include <CodKits_iOS/CKCoreTagList.h>
#include <CodKits_iOS/CKCoreTagListItem.h>
#include <CodKits_iOS/CKCoreOptionsList.h>
#include <CodKits_iOS/CKCoreOptionsListItem.h>
#include <CodKits_iOS/CKCoreDropdownAlert.h>
#include <CodKits_iOS/CKCoreHorizontaldBMeterView.h>
#include <CodKits_iOS/CKCoreVerticaldBMeterView.h>
#include <CodKits_iOS/CKCoreCirculardBMeterView.h>
#include <CodKits_iOS/CKCoreActionSheetMenu.h>

//----- GUI -----
#include <CodKits_iOS/CKCoreScreenMetrics.h>
#include <CodKits_iOS/CKCoreDynamicIsland.h>

//----- Sensors -----
#include <CodKits_iOS/CKCoreSensors.h>
#include <CodKits_iOS/CKCoreAltitude.h>
#include <CodKits_iOS/CKCoreLocation.h>
#include <CodKits_iOS/CKCoreMotionFitness.h>
#include <CodKits_iOS/CKCoreGyroscope.h>
#include <CodKits_iOS/CKCoreHeading.h>

//----- Wrappers -----
#include <CodKits_iOS/CKCoreAppleMusicKit.h>
#include <CodKits_iOS/CKCoreAppleMusicLibrary.h>
#include <CodKits_iOS/CKCoreAppleMusicPlayer.h>
#include <CodKits_iOS/CKCoreAppleMusicQuery.h>

//----- NSBundle -----
#include <CodKits_iOS/CKCoreNSBundle.h>

//----- NSViewController -----
#include <CodKits_iOS/CKCoreNSViewController.h>

//----- NSWindow -----
#include <CodKits_iOS/CKCoreNSWindow.h>

//----- NSTextField -----
#include <CodKits_iOS/CKCoreNSTextField.h>

//----- Audio -----
#include <CodKits_iOS/CKCoreSpeechRecognition.h>
#include <CodKits_iOS/CKCoreAudioSpectrogramView.h>

//----- Scenes -----
#include <CodKits_iOS/CKCoreSceneIntroVideo.h>
#include <CodKits_iOS/CKCoreSceneRequestMicrophoneAccess.h>
#include <CodKits_iOS/CKCoreSceneRequestSpeechRecognizerAccess.h>
#include <CodKits_iOS/CKCoreSceneRequestLocationAccess.h>
#include <CodKits_iOS/CKCoreSceneRequestAltitudeAccess.h>
#include <CodKits_iOS/CKCoreSceneRequestHeadingAccess.h>
